/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package de.nplusc.izc.iZpl;

import com.sun.net.httpserver.HttpServer;
import de.nplusc.izc.iZpl.GUI.PlayListManagingBackend;
import de.nplusc.izc.tools.baseTools.Messagers;
import de.nplusc.izc.tools.baseTools.Tools;
import java.io.IOException;
import java.net.BindException;
import java.net.InetAddress;
import java.net.InetSocketAddress;
import java.net.Socket;

/**
 *
 * @author LH
 */
public class PLServer
{
    
    public static PlProcessorV2 ppp=null;
    public PLServer(String plPath)
    {
        try
        {
            HttpServer server = HttpServer.create(new InetSocketAddress("localhost",9263), 0);//,InetAddress.getByName("localhost"));
            ppp = new PlProcessorV2();
            ppp.InitializeOnPath(plPath);
            PlayListManagingBackend.initPPP(ppp);
            server.createContext("/", ppp);//nimmt jeden beliebigen namen an
            server.createContext("/reload",new ReloadMgrT(ppp));
            server.createContext("/rcvr",new ReInitializer());
            server.createContext("/edit",new EditorLoader());
            server.setExecutor(null); // creates a default executor
            server.start();
        }
        catch(BindException xxx)
        {
            Messagers.SingleLineMsg("iZpl bereits gestartt; keine 2 instanzen möglich", "OKAY");
            System.exit(9263);
        }
        catch (IOException ex)
        {
            ex.printStackTrace();
        }
    }
    public PLServer(PlProcessorV2 pp)
    {
        try
        {
            HttpServer server = HttpServer.create(new InetSocketAddress("localhost",9263), 0);//,InetAddress.getByName("localhost"));
            server.createContext("/", pp);//nimmt jeden beliebigen namen an
            ppp=pp;
            PlayListManagingBackend.initPPP(ppp);
            server.createContext("/reload",new ReloadMgrT(ppp));
            server.createContext("/rcvr",new ReInitializer());
            server.createContext("/edit",new EditorLoader());
            server.setExecutor(null); // creates a default executor
            server.start();
        }
        catch(BindException xxx)
        {
            Messagers.SingleLineMsg("iZpl bereits gestartt; keine 2 instanzen möglich", "OKAY");
            System.exit(9263);
        }
        catch (IOException ex)
        {
            ex.printStackTrace();
        }
    }
}
